/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of SPI.xs. Do not edit this file, edit SPI.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "SPI.xs"
/**********************************************************************
 * PostgreSQL::InServer::SPI
 *
 * SPI interface for plperl.  
 *
 *    $PostgreSQL: pgsql/src/pl/plperl/SPI.xs,v 1.21 2010/01/20 01:08:21 adunstan Exp $
 *
 **********************************************************************/

/* this must be first: */
#include "postgres.h"
/* Defined by Perl */
#undef _

/* perl stuff */
#include "plperl.h"


/*
 * Interface routine to catch ereports and punt them to Perl
 */
static void
do_plperl_return_next(SV *sv)
{
	MemoryContext oldcontext = CurrentMemoryContext;

	PG_TRY();
	{
		plperl_return_next(sv);
	}
	PG_CATCH();
	{
		ErrorData  *edata;

		/* Must reset elog.c's state */
		MemoryContextSwitchTo(oldcontext);
		edata = CopyErrorData();
		FlushErrorState();

		/* Punt the error to Perl */
		croak("%s", edata->message);
	}
	PG_END_TRY();
}


#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 61 "SPI.c"

XS(XS__spi_exec_query); /* prototype to pass -Wmissing-prototypes */
XS(XS__spi_exec_query)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "spi_exec_query", "query, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char*	query = (char *)SvPV_nolen(ST(0));
#line 56 "SPI.xs"
		HV *ret_hash;
		int limit = 0;
#line 79 "SPI.c"
	SV *	RETVAL;
#line 59 "SPI.xs"
		if (items > 2)
			croak("Usage: spi_exec_query(query, limit) "
				  "or spi_exec_query(query)");
		if (items == 2)
			limit = SvIV(ST(1));
		ret_hash = plperl_spi_exec(query, limit);
		RETVAL = newRV_noinc((SV*) ret_hash);
#line 89 "SPI.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__return_next); /* prototype to pass -Wmissing-prototypes */
XS(XS__return_next)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "return_next", "rv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	rv = ST(0);
#line 73 "SPI.xs"
		do_plperl_return_next(rv);
#line 112 "SPI.c"
    }
    XSRETURN_EMPTY;
}


XS(XS__spi_query); /* prototype to pass -Wmissing-prototypes */
XS(XS__spi_query)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "spi_query", "query");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	query = (char *)SvPV_nolen(ST(0));
	SV *	RETVAL;
#line 79 "SPI.xs"
		RETVAL = plperl_spi_query(query);
#line 134 "SPI.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__spi_fetchrow); /* prototype to pass -Wmissing-prototypes */
XS(XS__spi_fetchrow)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "spi_fetchrow", "cursor");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	cursor = (char *)SvPV_nolen(ST(0));
	SV *	RETVAL;
#line 87 "SPI.xs"
		RETVAL = plperl_spi_fetchrow(cursor);
#line 158 "SPI.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__spi_prepare); /* prototype to pass -Wmissing-prototypes */
XS(XS__spi_prepare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "spi_prepare", "query, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char*	query = (char *)SvPV_nolen(ST(0));
	SV *	RETVAL;
#line 95 "SPI.xs"
		int i;
		SV** argv;
		if (items < 1) 
			Perl_croak(aTHX_ "Usage: spi_prepare(query, ...)");
		argv = ( SV**) palloc(( items - 1) * sizeof(SV*));
		for ( i = 1; i < items; i++) 
			argv[i - 1] = ST(i);
		RETVAL = plperl_spi_prepare(query, items - 1, argv);
		pfree( argv);
#line 190 "SPI.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__spi_exec_prepared); /* prototype to pass -Wmissing-prototypes */
XS(XS__spi_exec_prepared)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "spi_exec_prepared", "query, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	query = (char *)SvPV_nolen(ST(0));
#line 111 "SPI.xs"
		HV *ret_hash;
#line 213 "SPI.c"
	SV *	RETVAL;
#line 113 "SPI.xs"
		HV *attr = NULL;
		int i, offset = 1, argc;
		SV ** argv;
		if ( items < 1) 
			Perl_croak(aTHX_ "Usage: spi_exec_prepared(query, [\\%%attr,] " 
					   "[\\@bind_values])");
		if ( items > 1 && SvROK( ST( 1)) && SvTYPE( SvRV( ST( 1))) == SVt_PVHV)
		{ 
			attr = ( HV*) SvRV(ST(1));
			offset++;
		}
		argc = items - offset;
		argv = ( SV**) palloc( argc * sizeof(SV*));
		for ( i = 0; offset < items; offset++, i++) 
			argv[i] = ST(offset);
		ret_hash = plperl_spi_exec_prepared(query, attr, argc, argv);
		RETVAL = newRV_noinc((SV*)ret_hash);
		pfree( argv);
#line 234 "SPI.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__spi_query_prepared); /* prototype to pass -Wmissing-prototypes */
XS(XS__spi_query_prepared)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "spi_query_prepared", "query, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	query = (char *)SvPV_nolen(ST(0));
	SV *	RETVAL;
#line 138 "SPI.xs"
		int i;
		SV ** argv;
		if ( items < 1) 
			Perl_croak(aTHX_ "Usage: spi_query_prepared(query, "
					   "[\\@bind_values])");
		argv = ( SV**) palloc(( items - 1) * sizeof(SV*));
		for ( i = 1; i < items; i++) 
			argv[i - 1] = ST(i);
		RETVAL = plperl_spi_query_prepared(query, items - 1, argv);
		pfree( argv);
#line 267 "SPI.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS__spi_freeplan); /* prototype to pass -Wmissing-prototypes */
XS(XS__spi_freeplan)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "spi_freeplan", "query");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	query = (char *)SvPV_nolen(ST(0));
#line 155 "SPI.xs"
		plperl_spi_freeplan(query);
#line 290 "SPI.c"
    }
    XSRETURN_EMPTY;
}


XS(XS__spi_cursor_close); /* prototype to pass -Wmissing-prototypes */
XS(XS__spi_cursor_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "spi_cursor_close", "cursor");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	cursor = (char *)SvPV_nolen(ST(0));
#line 161 "SPI.xs"
		plperl_spi_cursor_close(cursor);
#line 311 "SPI.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_PostgreSQL__InServer__SPI); /* prototype to pass -Wmissing-prototypes */
XS(boot_PostgreSQL__InServer__SPI)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
        newXSproto("spi_exec_query", XS__spi_exec_query, file, "$;@");
        newXSproto("return_next", XS__return_next, file, "$");
        newXSproto("spi_query", XS__spi_query, file, "$");
        newXSproto("spi_fetchrow", XS__spi_fetchrow, file, "$");
        newXSproto("spi_prepare", XS__spi_prepare, file, "$;@");
        newXSproto("spi_exec_prepared", XS__spi_exec_prepared, file, "$;@");
        newXSproto("spi_query_prepared", XS__spi_query_prepared, file, "$;@");
        newXSproto("spi_freeplan", XS__spi_freeplan, file, "$");
        newXSproto("spi_cursor_close", XS__spi_cursor_close, file, "$");

    /* Initialisation Section */

#line 165 "SPI.xs"
    items = 0;  /* avoid 'unused variable' warning */

#line 346 "SPI.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

